#ifndef PLUGIN_H
#define PLUGIN_H

#include <dbus/dbus.h>

#define PLUGIN_ROOT_INTF "org.mageia.monitoring"
#define PLUGIN_ROOT_PATH "/org/mageia/monitoring"

typedef struct plugin_s plugin_t;
struct plugin_s {
    const char *name;
    const char *path;
    int fd;
    void *priv;
    int (*init)(plugin_t *plugin, DBusConnection *connection);
    void (*handle_incoming)(plugin_t *plugin, DBusConnection *connection);
    DBusHandlerResult (*handle_message)(DBusConnection *connection, DBusMessage *message, plugin_t *plugin);
    void (*deinit)(plugin_t *plugin, DBusConnection *connection);
};

#endif /* PLUGIN_H */
