#ifndef IFW_DBUS_H
#define IFW_DBUS_H

#include <dbus/dbus.h>
#include "ifw.h"

void ifw_dbus_apply_report_verdict(DBusConnection *connection, ifw_t *ifw, report_list_cell_t *report, int do_blacklist);

/* notify frontends of a new attack with a DBus signal */
void ifw_dbus_notify_attack(DBusConnection *bus, report_list_cell_t *report);

/* notify frontends of a new whitelist with a DBus signal */
void ifw_dbus_notify_whitelist(DBusConnection *bus, u_int32_t addr);

/* notify frontends of a new blacklist with a DBus signal */
void ifw_dbus_notify_blacklist(DBusConnection *bus, msg_usr_t *attack);

/* notify frontends that ifw data isn't usable with a DBus signal */
void ifw_dbus_notify_clear(DBusConnection *bus);

/* notify frontends that ifw has just been started */
void ifw_dbus_notify_init(DBusConnection *bus);

/* notify frontends that a user is aware of the attacks */ 
void ifw_dbus_notify_alert_ack(DBusConnection *bus);

/* notify frontends that a user is wants to review the attacks */ 
void ifw_dbus_notify_manage_request(DBusConnection *bus);

DBusHandlerResult ifw_dbus_get_mode(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_set_mode(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_get_reports(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_get_blacklist(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_set_blacklist_verdict(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_unblacklist(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_get_whitelist(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_whitelist(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_unwhitelist(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_clear_processed_reports(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_send_alert_ack(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);
DBusHandlerResult ifw_dbus_send_manage_request(DBusConnection *connection, DBusMessage *message, ifw_t *ifw);

#endif /* IFW_DBUS_H */
