#ifndef REPORT_LIST_H
#define REPORT_LIST_H

#include "list.h"
typedef struct list_head report_list_t;

#include "ifw.h"

typedef struct {
    struct list_head list;
    int seq;
    msg_usr_t info;
    char processed;
} report_list_cell_t;

void report_list_init(report_list_t *list);
report_list_cell_t *report_list_add(report_list_t *list, int seq, msg_usr_t *attack);
report_list_cell_t *report_list_find(report_list_t *list, u_int32_t addr, int include_processed);
report_list_cell_t *report_list_find_seq(report_list_t *list, int seq);
void report_list_remove(report_list_cell_t *cell);
void report_list_clear_processed(report_list_t *list);
void report_list_print(report_list_t *list);

#endif /* REPORT_LIST_H */
